/*
	|Pbg|[J[pΐ푊f[^쐬c[
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdarg.h>
#include "image.h"
#include "hex.h"

/* text.c */
int encodeText(unsigned char *, unsigned short *, const unsigned char *);
int makeFont(unsigned char *, const unsigned short *);

/* pattern.c */
int makePat(unsigned char *, const char *);

/* graph.c */
int packLine(unsigned char *, Image, int, int);

/* ^U */
#define FALSE	0
#define TRUE	1

/* Q[f[^ */
struct Game {
	int money_com;
	int money_man;
	int style;
	int graph_start;
	int text_gameover;
	struct Stage {
		int money_clear;
		int face_start;
		int text_start;
		int face_normal;
		int face_smile;
		int face_sad;
		int text_game;
		int text_prompt;
		int text_check;
		int text_call;
		int text_bid;
		int text_raise;
		int text_fold;
		int text_win;
		int text_lose;
		int text_clear;
		int graph_clear;
	} stage[32];
	int face_allclear;
	int text_allclear;
};

/* Ot@C̖O */
char logFileName[MAX_PATH] = "";

/*
	Oo͂
*/
static void print(char *str, ...)
{
	FILE *fp;
	va_list v;
	char buf[256];

	va_start(v, str);
	vsprintf(buf, str, v);
	va_end(v);

	fprintf(stderr, "%s", buf);
	fflush(stderr);
	if(strcmp(logFileName, "") == 0)
		return;

	if((fp = fopen(logFileName, "a")) == NULL)
		return;
	fprintf(fp, "%s", buf);
	fclose(fp);
}

/*
	󔒂?
*/
static int isBlank(char c)
{
	return c == ' ' || c == '\t' || c == '\r' || c == '\n';
}

/*
	I[L?
*/
static int isTerm(char c)
{
	return c == 0 || c == '\r' || c == '\n';
}

/*
	̋󔒂菜
*/
static char *strtrim(char *out, const char *in)
{
	int len;
	const char *p, *q;

	for(p = in; isBlank(*p) && *p != 0; p++)
		;
	for(q = in + strlen(in) - 1; isBlank(*q) && q != in; q--)
		;
	len = (int )(q - p);

	memmove(out, p, len);
	*(out + len + 1) = 0;
	return out;
}

/*
	CSVl𓾂
*/
static char *getValue(char *value, char **pointer)
{
	char *p = value;

redo:;
	/* 󔒂ǂݔ΂ */
	for(; isBlank(**pointer); (*pointer)++)
		;

	/* Rg? */
	if(**pointer == ';') {
		for(; !isTerm(**pointer); (*pointer)++)
			;
		goto redo;
	}

	/* ,? */
	if(**pointer == ',') {
		(*pointer)++;
		strcpy(value, "");
		return value;
	}

	/* l𓾂 */
	for(; !isTerm(**pointer) && **pointer != ',' && **pointer != ';'; (*pointer)++)
		*p++ = **pointer;
	*p = 0;

	/* ,? */
	if (**pointer == ',')
		(*pointer)++;

	strtrim(value, value);
	return value;
}

/*
	li[
*/
static int store(char *array[], const char *data)
{
	int i, len;

	for(i = 0; array[i] != NULL; i++)
		if(strcmp(array[i], data) == 0)
			return i;

	len = strlen(data);
	array[i] = malloc(len + 1);
	strcpy(array[i], data);
	return i;
}

/*
	f[^𓾂
*/
static int lengthof(char *array[])
{
	int i;

	for(i = 0; array[i] != NULL; i++)
		;

	return i;
}

/*
	pXgq̂𓾂
*/
static char *getBaseName(char *base, const char *path)
{
	char *p;

	strcpy(base, path);

	for(p = base + strlen(base) - 1; p > base; p--)
		if(*p == '.') {
			*p = 0;
			break;
		}
	return base;
}

/*
	pXfBNg𓾂
*/
static char *getDir(char *dir, const char *path)
{
	char *p;

	strcpy(dir, path);

	for(p = dir + strlen(dir) - 1; p > dir; p--)
		if(*p == '/' || *p == '\\') {
			*p = 0;
			return dir;
		} else if(*p == ':') {
			*(p + 1) = 0;
			return dir;
		}

	strcpy(dir, "");
	return dir;
}

/*
	pX쐬
*/
static char *makePath(char *path, const char *dir, const char *file)
{
	const char *p;

	if(strcmp(dir, "") == 0) {
		strcpy(path, file);
		return path;
	}

	for(p = file; *p != 0; p++)
		if(*p == '/' || *p == '\\' || *p == ':') {
			strcpy(path, file);
			return path;
		}

	sprintf(path, "%s/%s", dir, file);
	return path;
}

/*
	_vo͂
*/
static void dump(const unsigned char *buf, int len)
{
	const unsigned char *p, *q;

	for(p = buf; p < buf + len; p += 8) {
		printf("\t.db 0x%02x", *p);
		for(q = p + 1; q < p + 8 && q < buf + len; q++)
			printf(", 0x%02x", *q);
		printf("\n");
	}
}

/*
	C
*/
int main(int argc, char *argv[])
{
	static unsigned char bin[0x1000 * 8];
	Image img = IMG_NULL;
	struct Game game;
	int base = 0x127e;
	int base_text;
	int base_face;
	int base_graph;
	int size;
	int fd;
	int n = 0;
	int i;
	int j;
	int k;
	int y;
	int plane;
	int len;
	int address = 0;
	int graph_orig_size[256];
	int pos[256];
	unsigned short kanji[256];
	char tmp[256];
	char src[4096];
	char dir[MAX_PATH];
	char path[MAX_PATH];
	char *r = src;
	unsigned char *w = bin;
	char *text[256] = { NULL };
	char *face[32] = { NULL };
	char *graph[32] = { NULL };
	unsigned char *graph_line[1024] = { NULL };
	unsigned char *font_p;
	unsigned char *text_p[32];
	unsigned char *face_p[32];
	unsigned char *graph_p[32];
	unsigned char *graph_line_p[64];
	unsigned char *graph_top_p[32];
	unsigned char *game_init_p;
	unsigned char *game_p;

	imgParam.exit_when_error = FALSE;

	memset(&game, 0, sizeof(game));
	memset(kanji, 0, sizeof(kanji));

	/* \[Xt@Cǂݍ */
	if((fd = open(argv[1], O_RDONLY)) < 0) {
		print("CANNOT OPEN (%s)\n", argv[1]);
		return 1;
	}
	if(read(fd, src, sizeof(src)) >= sizeof(src)) {
		print("TOO LARGE (%s)\n", argv[1]);
		return 1;
	}
	close(fd);

	getDir(dir, argv[1]);
	sprintf(logFileName, "%s.log", getBaseName(path, argv[1]));
	unlink(logFileName);

	game.money_com = atoi(getValue(tmp, &r));
	game.money_man = atoi(getValue(tmp, &r));
	game.style = atoi(getValue(tmp, &r));
	if(strcmp(getValue(tmp, &r), "") != 0) {
		game.graph_start = store(graph, tmp);
		pos[game.graph_start] = atoi(getValue(tmp, &r));
	} else {
		game.graph_start = -1;
		getValue(tmp, &r);
	}
	game.text_gameover = store(text, getValue(tmp, &r));

	do {
		game.stage[n].money_clear = atoi(getValue(tmp, &r));
		game.stage[n].face_start = store(face, getValue(tmp, &r));
		game.stage[n].text_start = store(text, getValue(tmp, &r));
		game.stage[n].face_normal = store(face, getValue(tmp, &r));
		game.stage[n].face_smile = store(face, getValue(tmp, &r));
		game.stage[n].face_sad = store(face, getValue(tmp, &r));
		game.stage[n].text_game = store(text, getValue(tmp, &r));
		game.stage[n].text_prompt = store(text, getValue(tmp, &r));
		game.stage[n].text_check = store(text, getValue(tmp, &r));
		game.stage[n].text_call = store(text, getValue(tmp, &r));
		game.stage[n].text_bid = store(text, getValue(tmp, &r));
		game.stage[n].text_raise = store(text, getValue(tmp, &r));
		game.stage[n].text_fold = store(text, getValue(tmp, &r));
		game.stage[n].text_win = store(text, getValue(tmp, &r));
		game.stage[n].text_lose = store(text, getValue(tmp, &r));
		game.stage[n].text_clear = store(text, getValue(tmp, &r));
		game.stage[n].graph_clear = store(graph, getValue(tmp, &r));
		pos[game.stage[n].graph_clear] = atoi(getValue(tmp, &r));
	} while(game.stage[n++].money_clear != 0);

	game.face_allclear = store(face, getValue(tmp, &r));
	game.text_allclear = store(text, getValue(tmp, &r));

	/* 0 */
	*w++ = 0;
	*w++ = 0;

	/* CfbNX΂ */
	w += 2;
	w += 2;
	w += 2;
	w += lengthof(text) * 2;
	w += lengthof(face) * 2;
	w += lengthof(graph) * 2;

	/* eLXg */
	for(i = 0; text[i] != NULL; i++) {
		text_p[i] = w;
		*w = encodeText(w + 1, kanji, text[i]);
		w += *w + 1;
	}
	text_p[i] = w;

	/* tHg */
	font_p = w;
	w += makeFont(w, kanji);

	/* OtBbN */
	for(i = 0; face[i] != NULL; i++) {
		face_p[i] = w;
		if((len = makePat(w, makePath(path, dir, face[i]))) < 0) {
			print("CANNOT OPEN (%s)\n", face[i]);
			return 1;
		}
		w += len;
	}
	face_p[i] = w;

	/* OtBbN */
	for(i = 0; graph[i] != NULL; i++) {
		if(!imgLoadConv(&img, makePath(path, dir, graph[i]), IMG_GRAY, 144, 0)) {
			print("CANNOT OPEN (%s)\n", graph[i]);
			return 1;
		}

		graph_top_p[i] = w;
		graph_orig_size[i] = img.width * img.height * 2 / 8;

		j = 0;
		for(plane = 0; plane < 2; plane++)
			for(y = 0; y < img.height; y += 8) {
				len = packLine(tmp, img, y, plane);

				for(k = 0; graph_line[k] != NULL; k++)
					if(memcmp(tmp, graph_line[k], len) == 0)
						break;

				if(graph_line[k] == NULL) {
					graph_line[k + 0] = w;
					graph_line[k + 1] = NULL;

					memcpy(w, tmp, len);
					w += len;
				}

				graph_line_p[j++] = graph_line[k];
			}

		graph_p[i] = w;
		*w++ = img.height;
		*w++ = ((img.height + 7) / 8 + (img.height % 8 == 0 ? 1: 0)) * 2;
		*w++ = pos[i];

		j = 0;
		for(plane = 0; plane < 2; plane++) {
			for(y = 0; y < img.height; y += 8) {
				address = base + (int )(graph_line_p[j++] - bin);
				*w++ = address & 0xff;
				*w++ = address >> 8;
			}
			if(y % 8 == 0) {
				*w++ = address & 0xff;
				*w++ = address >> 8;
			}
		}

		imgFree(&img);
	}
	graph_top_p[i] = w;

	/* Q[ */
	base_text = 0;
	base_face = base_text + lengthof(text);
	base_graph = base_face + lengthof(face);

	game_init_p = w;
	*w++ = game.money_com;
	*w++ = game.money_man;
	*w++ = game.style;
	*w++ = game.graph_start >= 0 ? base_graph + game.graph_start: -1;
	*w++ = base_text + game.text_gameover;

	game_p = w;
	for(i = 0; i < n; i++) {
		*w++ = game.stage[i].money_clear;
		*w++ = base_face + game.stage[i].face_start;
		*w++ = base_text + game.stage[i].text_start;
		*w++ = base_face + game.stage[i].face_normal;
		*w++ = base_face + game.stage[i].face_smile;
		*w++ = base_face + game.stage[i].face_sad;
		*w++ = base_text + game.stage[i].text_game;
		*w++ = base_text + game.stage[i].text_prompt;
		*w++ = base_text + game.stage[i].text_check;
		*w++ = base_text + game.stage[i].text_call;
		*w++ = base_text + game.stage[i].text_bid;
		*w++ = base_text + game.stage[i].text_raise;
		*w++ = base_text + game.stage[i].text_fold;
		*w++ = base_text + game.stage[i].text_win;
		*w++ = base_text + game.stage[i].text_lose;
		*w++ = base_text + game.stage[i].text_clear;
		*w++ = base_graph + game.stage[i].graph_clear;
	}
	*w++ = -1;
	*w++ = base_face + game.face_allclear;
	*w++ = base_text + game.text_allclear;

	size = (int )(w - bin);

	/* CfbNX */
	w = bin;
	w++;
	w++;
	address = base + (int )(font_p - bin);
	*w++ = address & 0xff;
	*w++ = address >> 8;
	address = base + (int )(game_init_p - bin);
	*w++ = address & 0xff;
	*w++ = address >> 8;
	address = base + (int )(game_p - bin);
	*w++ = address & 0xff;
	*w++ = address >> 8;
	for(i = 0; text[i] != NULL; i++) {
		address = base + (int )(text_p[i] - bin);
		*w++ = address & 0xff;
		*w++ = address >> 8;
	}
	for(i = 0; face[i] != NULL; i++) {
		address = base + (int )(face_p[i] - bin);
		*w++ = address & 0xff;
		*w++ = address >> 8;
	}
	for(i = 0; graph[i] != NULL; i++) {
		address = base + (int )(graph_p[i] - bin);
		*w++ = address & 0xff;
		*w++ = address >> 8;
	}

	/* t@C */
	sprintf(tmp, "%s_n.txt", getBaseName(path, argv[1]));
	if(writeHexAbs(makePath(path, dir, tmp), bin, base, size, TRUE) == 0) {
		print("CANNOT WRITE (%s)\n", path);
		return 1;
	}
	sprintf(tmp, "%s.ihx", getBaseName(path, argv[1]));
	if(writeHexAbs(makePath(path, dir, tmp), bin, base, size, FALSE) == 0) {
		print("CANNOT WRITE (%s)\n", path);
		return 1;
	}

#if 0
	/* \[Xt@Co͂ */
	dump(bin, size);
#endif

	/* ʂo͂ */
	print("* HEADER *\n");
	print("\t%04X\t%02X%02X\t%s\n", base + 0, bin[1], bin[0], "FONT");
	print("\t%04X\t%02X%02X\t%s\n", base + 2, bin[3], bin[2], "GAME_INIT");
	print("\t%04X\t%02X%02X\t%s\n", base + 4, bin[5], bin[4], "GAME");

	print("* INDEX *\n");
	for(i = 0; text[i] != NULL; i++) {
		address = base + (base_text + i + 3) * 2;
		print("\t%04X\t%02X%02X\t%s\n", address, bin[(address - base) + 1], bin[address - base], text[i]);
	}
	for(i = 0; face[i] != NULL; i++) {
		address = base + (base_face + i + 3) * 2;
		print("\t%04X\t%02X%02X\t%s\n", address, bin[(address - base) + 1], bin[address - base], face[i]);
	}
	for(i = 0; graph[i] != NULL; i++) {
		address = base + (base_graph + i + 3) * 2;
		print("\t%04X\t%02X%02X\t%s\n", address, bin[(address - base) + 1], bin[address - base], graph[i]);
	}
	print("* TEXT *\n");
	for(i = 0; text[i] != NULL; i++)
		print("\t%04X\t%d\t%s\n", base + (int )(text_p[i] - bin), (int )(text_p[i + 1] - text_p[i]), text[i]);
	print("* FONT *\n");
		print("\t%04X\t%d\n", base + (int )(font_p - bin), (int )(face_p[0] - font_p));
	print("* FACE *\n");
	for(i = 0; face[i] != NULL; i++)
		print("\t%04X\t%d\t%s\n", base + (int )(face_p[i] - bin), (int )(face_p[i + 1] - face_p[i]), face[i]);
	print("* GRAPHIC *\n");
	for(i = 0; graph[i] != NULL; i++)
		print("\t%04X\t%d(%d%%)\t%s\n", base + (int )(graph_p[i] - bin), (int )(graph_top_p[i + 1] - graph_top_p[i]), (int )(graph_top_p[i + 1] - graph_top_p[i]) * 100 / graph_orig_size[i], graph[i]);
	print("* GAME_INIT *\n");
	print("\t%04X\t%d\n", base + (int )(game_init_p - bin), (int )(game_p - game_init_p));
	print("* GAME *\n");
	print("\t%04X\t%d\n", base + (int )(game_p - bin), (int )(bin + size - game_p));
	print("\n");

	print("%s:%04X-%04X\n", path, base, base + size - 1);
	return 0;
}

/* eof */
